#!/usr/bin/perl -T
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use CGI qw(:standard :netscape);

my $r = param('rig');
unless ($r)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($r);
my @d = $rig->list_devices_control('multiplex');
my @devs = ();
foreach my $name (@d)
{
    ### exclude readonly devices ###
    push @devs,$name unless ($rig->get_device('multiplex',$name)->readonly);
}

if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    #### husk at aendre accessparameter til det relevante for scriptet!! ####
    if (&login_ok())
    {
        &print_header("Set gas multiplexer for rig ".$rig->name);
        if ($ENV{'HTTP_USER_AGENT'} =~ /MSIE/)
        {
	    print RFC_start_html(-title=>"Set gas multiplexer for rig ".$rig->name, -style=>{src=>'/celltest/RFCcontrol.css'},-onBlur=>'initiateSelfClosing()');
        }
        else
        {
	    print RFC_start_html(-title=>"Set gas multiplexer for rig ".$rig->name, -style=>{src=>'/celltest/RFCcontrol.css'},-onBlur=>'self.close()');
	}
	print '<center>';
	print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr height=1>';
	print '<td width="5%"></td>';
	print '<td width="30%"></td>';
	print '<td width="25%"></td>';
	print '<td width="5%"></td>';
	print '<td width="30%"></td>';
	print '<td width="5%"></td>';
	print '</tr>';
	print start_form(-name=>'sofc');
	print '<tr><td colspan=6 class=heading> Set gas multiplexer for rig ',$rig->name,'</td></tr>';
	print '<tr><td></td><th colspan=2>';
	my ($t,$r,$j) = ('','','');
	if (@devs > 1)
	{
	    print 'Select multiplexer';
	    print popup_menu(-name=>'device',-values=>['',sort @devs],-default=>'',-class=>'textfield',-force=>'1',-onchange=>'set_default()');	    
	    $j = "    var element = document.sofc.device;\n";
	    $j .= "    opener.document.multiplex.device.value = element[element.selectedIndex].value;\n";
	}
	else
	{
	    my $d = $rig->get_device('multiplex',$devs[0]);
	    $t = $d->gas;
	    $j = "    opener.document.multiplex.device.value = document.sofc.device.value;\n";
	    print hidden(-name=>'device',-value=>$devs[0],-force=>1);
	}
	print '</th><td colspan=1>';
	print '</td><td rowspan=3>';
	print button(-name=>'test',-value=>'Ok',-class=>'s3',-OnClick=>'set_gas()');
	print '</td></tr>',"\n";
	print '<tr><td></td><th> Status: </th><td>';
        if (@devs > 1)
        {
            print popup_menu(-name=>'gas_select',-values=>[''],-default=>'',-class=>'textfield',-force=>'1');
        }
        else
        {
	    my $d = $rig->get_device('multiplex',$devs[0]);
            print popup_menu(-name=>'gas_select',-values=>['',$d->gasses],-default=>$t,-class=>'textfield',-force=>'1');
        }
	print '</td><th></th></tr>',"\n";
	print end_form;
	print <<END;

<script language=javascript>

function set_default()
{
    var element = document.sofc.device;
    var id = element.selectedIndex;
    var name = element[id].value;
    document.sofc.gas_select.disabled = true; 
    run_ajax('rig_ajax_run.cgi','&action=run_device_function&type=multiplex&dname='+name+'&function=gasses',load_default);
}

function load_default(res)
{
    var element = document.sofc.device;
    var id = element.selectedIndex;
    var name = element[id].value;
    var arr = res.split("\\n");
    if (arr[0] == "OK")
    {
	var e2 = document.sofc.gas_select;
	e2.length = 0;
	for( x = 1; x < arr.length; x++)
	{
	    var optn = document.createElement("OPTION");
	    optn.value = arr[x];
	    optn.text = arr[x];
	    e2.options.add(optn);
	}
	run_ajax('rig_ajax_run.cgi','&action=run_device_function&type=multiplex&dname='+name+'&function=gas',set_default_ajax);
    }
    else
    {
        alert(res);
    }
}


function load_default_none(res)
{
    var element = document.sofc.device;
    var id = element.selectedIndex;
    var name = element[id].value;
    var arr = res.split("\\n");
    if (arr[0] == "OK")
    {
	var e2 = document.sofc.gas_select;
	e2.length = 0;
	var optn = document.createElement("OPTION");
	optn.value = '';
	optn.text = '';
	e2.options.add(optn);
	for( x = 1; x < arr.length; x++)
	{
	    var optn = document.createElement("OPTION");
	    optn.value = arr[x];
	    optn.text = arr[x];
	    e2.options.add(optn);
	}
	run_ajax('rig_ajax_run.cgi','&action=run_device_function&type=multiplex&dname='+name+'&function=gas',set_default_ajax);
    }
    else
    {
        alert(res);
    }
}

function set_default_ajax(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK")
    {
	if (arr.length == 2 && arr[1].length < 2)
	{
	    var element = document.sofc.gas_select;
	    if (element[0].value == "")
	    {
		document.sofc.gas_select.selectedIndex = 0;
	    }
	    else
	    {
		var e3 = document.sofc.device;
		var id = e3.selectedIndex;
		var name = e3[id].value;
		run_ajax('rig_ajax_run.cgi','&action=run_device_function&type=multiplex&dname='+name+'&function=gasses',load_default_none);
	    }
	}
	else
	{
	    var element = document.sofc.gas_select;
	    var sid = 0;
	    for( x = 0; x < element.length; x++)
	    {
		if (element[x].value == arr[1])
		{
		    sid = x;
		}
	    }
	    document.sofc.gas_select.selectedIndex = sid;	
	}
	document.sofc.gas_select.disabled = false; 
    }
    else
    {
        alert(res);
    }
}

function set_gas()
{
$j    
    opener.document.multiplex.gas.value = document.sofc.gas_select[document.sofc.gas_select.selectedIndex].value;
    opener.set_multiplex_go();
    self.close();
}

</script>

END

        print end_html;
    }
    else
    {
        &not_auth;
    }
}

